/*---------------------------------------------------------------------------*/
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
//      License : The modified BSD license
//
//                                Copyright 2002- hiyohiyo All rights reserved.
/*---------------------------------------------------------------------------*/

#include "stdafx.h"
#include "CrystalCPUID.h"
#include "CrystalCPUIDDlg.h"
#include "DummyDlg.h"

#include "../common/DialogTemplateEx.h"

#include <mmsystem.h>
#pragma comment(lib, "winmm.lib")

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCrystalCPUIDApp

BEGIN_MESSAGE_MAP(CCrystalCPUIDApp, CWinApp)
	//{{AFX_MSG_MAP(CCrystalCPUIDApp)
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCrystalCPUIDApp 

CCrystalCPUIDApp::CCrystalCPUIDApp()
{
}

/////////////////////////////////////////////////////////////////////////////

CCrystalCPUIDApp theApp;

int gLanguage = ENGLISH;
CBitmap gBackBitmap;
CBrush gBackBrush;
COLORREF gTextColor;
BOOL gFlagBack = FALSE;

int gDialogID = IDD_CRYSTALCPUID_DIALOG; // Default Dialog Templete

/////////////////////////////////////////////////////////////////////////////

BOOL CCrystalCPUIDApp::InitInstance()
{
	HANDLE hMutex = ::CreateMutex(NULL,FALSE,"CrystalCPUID");
	if (GetLastError()==ERROR_ALREADY_EXISTS){return FALSE;}
	
	// Init m_path & m_ini 
	char* ptrEnd;
	::GetModuleFileName(NULL, m_path, MAX_PATH);
	::GetModuleFileName(NULL, m_ini, MAX_PATH);
	if ( (ptrEnd = strrchr(m_path, '\\')) != NULL ){
		*ptrEnd = '\0';
	}
	if ( (ptrEnd = strrchr(m_ini, '.')) != NULL ){
		*ptrEnd = '\0';
		strcat(m_ini, ".ini");
	}

	// Select Dialog Templete & ini File
	for(int i=0; i<__argc; i++)
    {
		if( ! _stricmp(__argv[i],"-D24") || ! _stricmp(__argv[i],"/D24") ){
			gDialogID = IDD_CRYSTALCPUID_DIALOG_24;
		}
		if( ! _stricmp(__argv[i],"-D26") || ! _stricmp(__argv[i],"/D26") ){
			gDialogID = IDD_CRYSTALCPUID_DIALOG_26;
		}
 		if( ! _strnicmp(__argv[i],"-INI=",5) || ! _strnicmp(__argv[i],"/INI=",5) ){
				sprintf(m_ini,"%s\\%s",m_path,&__argv[i][5]);
		}
	}
	
	free((void*)m_pszProfileName);
	m_pszProfileName = strdup(m_ini);

	// Set Language
	char str[256];
	GetPrivateProfileString("Setting","Language","en",str,256,m_pszProfileName);
	if( ! strcmp(str,"en") ){
		gLanguage = ENGLISH;
	}else{
		gLanguage = JAPANESE;
	}

	GetPrivateProfileString("Setting","DialogStyle","",str,256,m_pszProfileName);
	if( ! strcmp(str,"24") ){
		gDialogID = IDD_CRYSTALCPUID_DIALOG_24;
	}
	if( ! strcmp(str,"26") ){
		gDialogID = IDD_CRYSTALCPUID_DIALOG_26;
	}

	// Multimedia Timer Setting
	TIMECAPS tc;
	timeGetDevCaps(&tc,sizeof(TIMECAPS));
	timeBeginPeriod(tc.wPeriodMin);

	AfxEnableControlContainer();

	ConnectSysInfo( MODE_PCI | MODE_DMI );

	CDummyDlg dlg;
	m_pMainWnd = &dlg;
	dlg.DoModal();

	DisconnectSysInfo();

	// Multimedia Timer Setting
	timeEndPeriod(tc.wPeriodMin);

	::ReleaseMutex(hMutex);
	::CloseHandle(hMutex);

	return FALSE;
}


/////////////////////////////////////////////////////////////////////////////
// SysInfo.dll Load & Unload
/////////////////////////////////////////////////////////////////////////////

typedef ISysInfo* (*_CreateSysInfo) (DWORD);
typedef void (*_DestroySysInfo) (ISysInfo*);

BOOL CCrystalCPUIDApp::ConnectSysInfo(DWORD Mode)
{
	hSysInfoLib = LoadLibrary("SysInfo.dll");
	if(hSysInfoLib != NULL){
		_CreateSysInfo pCreateSysInfo = (_CreateSysInfo) GetProcAddress (hSysInfoLib,"CreateSysInfo");
		SysInfo = pCreateSysInfo(Mode);
		return TRUE;
	}else{
		MessageBoxEx(gLanguage,
			IDS_NOT_FOUND_SYS_INFO_DLL_EN,
			IDS_NOT_FOUND_SYS_INFO_DLL_JP);
		exit(0);
		return FALSE;
	}
}

BOOL CCrystalCPUIDApp::DisconnectSysInfo()
{
	if(hSysInfoLib !=NULL){
		_DestroySysInfo pDestroySysInfo = (_DestroySysInfo) GetProcAddress (hSysInfoLib,"DestroySysInfo");
		pDestroySysInfo(SysInfo);
		FreeLibrary(hSysInfoLib);
		hSysInfoLib = NULL;
		SysInfo = NULL;
		return TRUE;
	}else{
		return FALSE;
	}
}